// Code generated by gobind. DO NOT EDIT.

// Java class org.ethereum.geth.Geth is a proxy for talking to a Go program.
//
//   autogenerated by gobind -lang=java -javapkg=org.ethereum github.com/ethereum/go-ethereum/mobile
package org.ethereum.geth;

import go.Seq;

public abstract class Geth {
	static {
		Seq.touch(); // for loading the native library
		_init();
	}
	
	private Geth() {} // uninstantiable
	
	// touch is called from other bound packages to initialize this package
	public static void touch() {}
	
	private static native void _init();
	
	private static final class proxyFilterLogsHandler implements Seq.Proxy, FilterLogsHandler {
		private final int refnum;
		
		@Override public final int incRefnum() {
		      Seq.incGoRef(refnum, this);
		      return refnum;
		}
		
		proxyFilterLogsHandler(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
		
		public native void onError(String failure);
		public native void onFilterLogs(Log log);
	}
	private static final class proxyNewHeadHandler implements Seq.Proxy, NewHeadHandler {
		private final int refnum;
		
		@Override public final int incRefnum() {
		      Seq.incGoRef(refnum, this);
		      return refnum;
		}
		
		proxyNewHeadHandler(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
		
		public native void onError(String failure);
		public native void onNewHead(Header header);
	}
	private static final class proxyNewMessageHandler implements Seq.Proxy, NewMessageHandler {
		private final int refnum;
		
		@Override public final int incRefnum() {
		      Seq.incGoRef(refnum, this);
		      return refnum;
		}
		
		proxyNewMessageHandler(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
		
		public native void onError(String failure);
		public native void onNewMessage(Message message);
	}
	private static final class proxySigner implements Seq.Proxy, Signer {
		private final int refnum;
		
		@Override public final int incRefnum() {
		      Seq.incGoRef(refnum, this);
		      return refnum;
		}
		
		proxySigner(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
		
		public native Transaction sign(Address addr, Transaction unsignedTx) throws Exception;
	}
	
	/**
	 * LightScryptN is the N parameter of Scrypt encryption algorithm, using 4MB
	memory and taking approximately 100ms CPU time on a modern processor.
	 */
	public static final long LightScryptN = 4096;
	/**
	 * LightScryptP is the P parameter of Scrypt encryption algorithm, using 4MB
	memory and taking approximately 100ms CPU time on a modern processor.
	 */
	public static final long LightScryptP = 6;
	public static final long LightestSync = 5L;
	/**
	 * StandardScryptN is the N parameter of Scrypt encryption algorithm, using 256MB
	memory and taking approximately 1s CPU time on a modern processor.
	 */
	public static final long StandardScryptN = 262144;
	/**
	 * StandardScryptP is the P parameter of Scrypt encryption algorithm, using 256MB
	memory and taking approximately 1s CPU time on a modern processor.
	 */
	public static final long StandardScryptP = 1;
	/**
	 * Deprecated: This used to be SyncModeCeloLatestSync. Geth will panic if started in this mode.
	Use LightestSync instead.
	 */
	public static final long SyncModeDeprecatedSync = 4L;
	public static final long SyncModeFastSync = 2L;
	public static final long SyncModeFullSync = 1L;
	public static final long SyncModeLightSync = 3L;
	/**
	 * I am intentionally duplicating these constants different from downloader.SyncMode integer values, to ensure the
	backwards compatibility where the mobile node defaults to LightSync.
	 */
	public static final long SyncModeUnset = 0L;
	
	public static native String alfajoresGenesis();
	public static native String baklavaGenesis();
	/**
	 * BindContract creates a low level contract interface through which calls and
	transactions may be made through.
	 */
	public static native BoundContract bindContract(Address address, String abiJSON, EthereumClient client) throws Exception;
	/**
	 * DecodeFromHex decodes a hex string with 0x prefix.
	 */
	public static native byte[] decodeFromHex(String s) throws Exception;
	/**
	 * DeployContract deploys a contract onto the Ethereum blockchain and binds the
	deployment address with a wrapper.
	 */
	public static native BoundContract deployContract(TransactOpts opts, String abiJSON, byte[] bytecode, EthereumClient client, Interfaces args) throws Exception;
	/**
	 * EncodeToHex encodes b as a hex string with 0x prefix.
	 */
	public static native String encodeToHex(byte[] b);
	/**
	 * FoundationBootnodes returns the enode URLs of the P2P bootstrap nodes operated
	by the foundation running the V5 discovery protocol.
	 */
	public static native Enodes foundationBootnodes();
	/**
	 * MainnetGenesis returns the JSON spec to use for the main Ethereum network. It
	is actually empty since that defaults to the hard coded binary genesis block.
	 */
	public static native String mainnetGenesis();
	/**
	 * NewAddressFromBytes converts a slice of bytes to a hash value.
	 */
	public static native Address newAddressFromBytes(byte[] binary) throws Exception;
	/**
	 * NewAddressFromHex converts a hex string to a address value.
	 */
	public static native Address newAddressFromHex(String hex) throws Exception;
	/**
	 * NewAddresses creates a slice of uninitialized addresses.
	 */
	public static native Addresses newAddresses(long size);
	/**
	 * NewAddressesEmpty creates an empty slice of Addresses values.
	 */
	public static native Addresses newAddressesEmpty();
	/**
	 * NewBigInt allocates and returns a new BigInt set to x.
	 */
	public static native BigInt newBigInt(long x);
	/**
	 * NewBigInts creates a slice of uninitialized big numbers.
	 */
	public static native BigInts newBigInts(long size);
	/**
	 * NewBlockFromJSON parses a block from a JSON data dump.
	 */
	public static native Block newBlockFromJSON(String data) throws Exception;
	/**
	 * NewBlockFromRLP parses a block from an RLP data dump.
	 */
	public static native Block newBlockFromRLP(byte[] data) throws Exception;
	/**
	 * NewCallMsg creates an empty contract call parameter list.
	 */
	public static native CallMsg newCallMsg();
	/**
	 * NewCallOpts creates a new option set for contract calls.
	 */
	public static native CallOpts newCallOpts();
	/**
	 * NewContext returns a non-nil, empty Context. It is never canceled, has no
	values, and has no deadline. It is typically used by the main function,
	initialization, and tests, and as the top-level Context for incoming requests.
	 */
	public static native Context newContext();
	/**
	 * NewContractCreation creates a new transaction for deploying a new contract with
	the given properties.
	 */
	public static native Transaction newContractCreation(long nonce, BigInt amount, long gasLimit, BigInt gasPrice, byte[] data);
	public static native Criteria newCriteria(byte[] topic);
	/**
	 * NewEnode parses a node designator.
	
	There are two basic forms of node designators
	  - incomplete nodes, which only have the public key (node ID)
	  - complete nodes, which contain the public key and IP/Port information
	
	For incomplete nodes, the designator must look like one of these
	
	   enode://&lt;hex node id&gt;
	   &lt;hex node id&gt;
	
	For complete nodes, the node ID is encoded in the username portion
	of the URL, separated from the host by an @ sign. The hostname can
	only be given as an IP address, DNS domain names are not allowed.
	The port in the host name section is the TCP listening port. If the
	TCP and UDP (discovery) ports differ, the UDP port is specified as
	query parameter &#34;discport&#34;.
	
	In the following example, the node URL describes
	a node with IP address 10.3.58.6, TCP listening port 30303
	and UDP discovery port 30301.
	
	   enode://&lt;hex node id&gt;@10.3.58.6:30303?discport=30301
	 */
	public static native Enode newEnode(String rawurl) throws Exception;
	/**
	 * NewEnodes creates a slice of uninitialized enodes.
	 */
	public static native Enodes newEnodes(long size);
	/**
	 * NewEnodesEmpty creates an empty slice of Enode values.
	 */
	public static native Enodes newEnodesEmpty();
	/**
	 * NewEthereumClient connects a client to the given URL.
	 */
	public static native EthereumClient newEthereumClient(String rawurl) throws Exception;
	/**
	 * NewFilterQuery creates an empty filter query for contract log filtering.
	 */
	public static native FilterQuery newFilterQuery();
	/**
	 * NewHashFromBytes converts a slice of bytes to a hash value.
	 */
	public static native Hash newHashFromBytes(byte[] binary) throws Exception;
	/**
	 * NewHashFromHex converts a hex string to a hash value.
	 */
	public static native Hash newHashFromHex(String hex) throws Exception;
	/**
	 * NewHashes creates a slice of uninitialized Hashes.
	 */
	public static native Hashes newHashes(long size);
	/**
	 * NewHashesEmpty creates an empty slice of Hashes values.
	 */
	public static native Hashes newHashesEmpty();
	/**
	 * NewHeaderFromJSON parses a header from a JSON data dump.
	 */
	public static native Header newHeaderFromJSON(String data) throws Exception;
	/**
	 * NewHeaderFromRLP parses a header from an RLP data dump.
	 */
	public static native Header newHeaderFromRLP(byte[] data) throws Exception;
	/**
	 * NewInterface creates a new empty interface that can be used to pass around
	generic types.
	 */
	public static native Interface newInterface();
	/**
	 * NewInterfaces creates a slice of uninitialized interfaces.
	 */
	public static native Interfaces newInterfaces(long size);
	/**
	 * NewKeyStore creates a keystore for the given directory.
	 */
	public static native KeyStore newKeyStore(String keydir, long scryptN, long scryptP);
	/**
	 * NewKeyedTransactor is a utility method to easily create a transaction signer
	from a single private key.
	 */
	public static native TransactOpts newKeyedTransactOpts(byte[] keyJson, String passphrase) throws Exception;
	public static native NewMessage newNewMessage();
	/**
	 * NewNode creates and configures a new Geth node.
	 */
	public static native Node newNode(String datadir, NodeConfig config) throws Exception;
	/**
	 * NewNodeConfig creates a new node option set, initialized to the default values.
	 */
	public static native NodeConfig newNodeConfig();
	/**
	 * NewReceiptFromJSON parses a transaction receipt from a JSON data dump.
	 */
	public static native Receipt newReceiptFromJSON(String data) throws Exception;
	/**
	 * NewReceiptFromRLP parses a transaction receipt from an RLP data dump.
	 */
	public static native Receipt newReceiptFromRLP(byte[] data) throws Exception;
	/**
	 * NewTopics creates a slice of uninitialized Topics.
	 */
	public static native Topics newTopics(long size);
	/**
	 * NewTopicsEmpty creates an empty slice of Topics values.
	 */
	public static native Topics newTopicsEmpty();
	/**
	 * NewTransactOpts creates a new option set for contract transaction.
	 */
	public static native TransactOpts newTransactOpts();
	/**
	 * NewTransaction creates a new transaction with the given properties.
	 */
	public static native Transaction newTransaction(long nonce, Address to, BigInt amount, long gasLimit, BigInt gasPrice, Address feeCurrency, Address gatewayFeeRecipient, BigInt gatewayFee, byte[] data);
	/**
	 * NewTransactionFromJSON parses a transaction from a JSON data dump.
	 */
	public static native Transaction newTransactionFromJSON(String data) throws Exception;
	/**
	 * NewTransactionFromRLP parses a transaction from an RLP data dump.
	 */
	public static native Transaction newTransactionFromRLP(byte[] data) throws Exception;
	/**
	 * NewWhisperClient connects a client to the given URL.
	 */
	public static native WhisperClient newWhisperClient(String rawurl) throws Exception;
	/**
	 * Note: A call to SetVerbosity after a call to SendLogsToFile will disable file logging.
	That&#39;s just how currently the code is structured. It is not an issue since we are going
	to make the calls sequentially at the time of initialization and can choose a particular
	order.
	Logs will be sent to this file along with the logcat.
	format has to be term or json. Anything else will cause the app to panic.
	 */
	public static native boolean sendLogsToFile(String filename, long level, String format);
	/**
	 * SetVerbosity sets the global verbosity level (between 0 and 6 - see logger/verbosity.go).
	 */
	public static native void setVerbosity(long level);
}
