// Code generated by gobind. DO NOT EDIT.

// Java class org.ethereum.geth.NodeConfig is a proxy for talking to a Go program.
//
//   autogenerated by gobind -lang=java -javapkg=org.ethereum github.com/ethereum/go-ethereum/mobile
package org.ethereum.geth;

import go.Seq;

/**
 * NodeConfig represents the collection of configuration values to fine tune the Geth
node embedded into a mobile process. The available values are a subset of the
entire API provided by go-ethereum to reduce the maintenance surface and dev
complexity.
 */
public final class NodeConfig implements Seq.Proxy {
	static { Geth.touch(); }
	
	private final int refnum;
	
	@Override public final int incRefnum() {
	      Seq.incGoRef(refnum, this);
	      return refnum;
	}
	
	/**
	 * NewNodeConfig creates a new node option set, initialized to the default values.
	 */
	public NodeConfig() {
		this.refnum = __NewNodeConfig();
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewNodeConfig();
	
	NodeConfig(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
	
	/**
	 * Bootstrap nodes used to establish connectivity with the rest of the network.
	 */
	public final native Enodes getBootstrapNodes();
	/**
	 * Bootstrap nodes used to establish connectivity with the rest of the network.
	 */
	public final native void setBootstrapNodes(Enodes v);
	
	/**
	 * MaxPeers is the maximum number of peers that can be connected. If this is
	set to zero, then only the configured static and trusted peers can connect.
	 */
	public final native long getMaxPeers();
	/**
	 * MaxPeers is the maximum number of peers that can be connected. If this is
	set to zero, then only the configured static and trusted peers can connect.
	 */
	public final native void setMaxPeers(long v);
	
	/**
	 * NoDiscovery indicates whether the node should not participate in p2p discovery
	 */
	public final native boolean getNoDiscovery();
	/**
	 * NoDiscovery indicates whether the node should not participate in p2p discovery
	 */
	public final native void setNoDiscovery(boolean v);
	
	/**
	 * EthereumEnabled specifies whether the node should run the Ethereum protocol.
	 */
	public final native boolean getEthereumEnabled();
	/**
	 * EthereumEnabled specifies whether the node should run the Ethereum protocol.
	 */
	public final native void setEthereumEnabled(boolean v);
	
	/**
	 * EthereumNetworkID is the network identifier used by the Ethereum protocol to
	decide if remote peers should be accepted or not.
	 */
	public final native long getEthereumNetworkID();
	/**
	 * EthereumNetworkID is the network identifier used by the Ethereum protocol to
	decide if remote peers should be accepted or not.
	 */
	public final native void setEthereumNetworkID(long v);
	
	/**
	 * EthereumGenesis is the genesis JSON to use to seed the blockchain with. An
	empty genesis state is equivalent to using the mainnet&#39;s state.
	 */
	public final native String getEthereumGenesis();
	/**
	 * EthereumGenesis is the genesis JSON to use to seed the blockchain with. An
	empty genesis state is equivalent to using the mainnet&#39;s state.
	 */
	public final native void setEthereumGenesis(String v);
	
	/**
	 * EthereumDatabaseCache is the system memory in MB to allocate for database caching.
	A minimum of 16MB is always reserved.
	 */
	public final native long getEthereumDatabaseCache();
	/**
	 * EthereumDatabaseCache is the system memory in MB to allocate for database caching.
	A minimum of 16MB is always reserved.
	 */
	public final native void setEthereumDatabaseCache(long v);
	
	/**
	 * EthereumNetStats is a netstats connection string to use to report various
	chain, transaction and node stats to a monitoring server.
	
	It has the form &#34;nodename:secret@host:port&#34;
	 */
	public final native String getEthereumNetStats();
	/**
	 * EthereumNetStats is a netstats connection string to use to report various
	chain, transaction and node stats to a monitoring server.
	
	It has the form &#34;nodename:secret@host:port&#34;
	 */
	public final native void setEthereumNetStats(String v);
	
	/**
	 * HTTPHost is the host interface on which to start the HTTP RPC server. If this
	field is empty, no HTTP API endpoint will be started.
	 */
	public final native String getHTTPHost();
	/**
	 * HTTPHost is the host interface on which to start the HTTP RPC server. If this
	field is empty, no HTTP API endpoint will be started.
	 */
	public final native void setHTTPHost(String v);
	
	/**
	 * HTTPPort is the TCP port number on which to start the HTTP RPC server. The
	default zero value is/ valid and will pick a port number randomly (useful
	for ephemeral nodes).
	 */
	public final native long getHTTPPort();
	/**
	 * HTTPPort is the TCP port number on which to start the HTTP RPC server. The
	default zero value is/ valid and will pick a port number randomly (useful
	for ephemeral nodes).
	 */
	public final native void setHTTPPort(long v);
	
	/**
	 * HTTPVirtualHosts is a comma separated list of virtual hostnames which are allowed on incoming requests.
	This is by default {&#39;localhost&#39;}. Using this prevents attacks like
	DNS rebinding, which bypasses SOP by simply masquerading as being within the same
	origin. These attacks do not utilize CORS, since they are not cross-domain.
	By explicitly checking the Host-header, the server will not allow requests
	made against the server with a malicious host domain.
	Requests using ip address directly are not affected
	 */
	public final native String getHTTPVirtualHosts();
	/**
	 * HTTPVirtualHosts is a comma separated list of virtual hostnames which are allowed on incoming requests.
	This is by default {&#39;localhost&#39;}. Using this prevents attacks like
	DNS rebinding, which bypasses SOP by simply masquerading as being within the same
	origin. These attacks do not utilize CORS, since they are not cross-domain.
	By explicitly checking the Host-header, the server will not allow requests
	made against the server with a malicious host domain.
	Requests using ip address directly are not affected
	 */
	public final native void setHTTPVirtualHosts(String v);
	
	/**
	 * HTTPModules is a comma separated list of API modules to expose via the HTTP RPC interface.
	If the module list is empty, all RPC API endpoints designated public will be
	exposed.
	 */
	public final native String getHTTPModules();
	/**
	 * HTTPModules is a comma separated list of API modules to expose via the HTTP RPC interface.
	If the module list is empty, all RPC API endpoints designated public will be
	exposed.
	 */
	public final native void setHTTPModules(String v);
	
	/**
	 * WhisperEnabled specifies whether the node should run the Whisper protocol.
	 */
	public final native boolean getWhisperEnabled();
	/**
	 * WhisperEnabled specifies whether the node should run the Whisper protocol.
	 */
	public final native void setWhisperEnabled(boolean v);
	
	/**
	 * Listening address of pprof server.
	 */
	public final native String getPprofAddress();
	/**
	 * Listening address of pprof server.
	 */
	public final native void setPprofAddress(String v);
	
	/**
	 * Sync mode for the node (eth/downloader/modes.go)
	This has to be integer since Enum exports to Java are not supported by &#34;gomobile&#34;
	See getSyncMode(syncMode int)
	 */
	public final native long getSyncMode();
	/**
	 * Sync mode for the node (eth/downloader/modes.go)
	This has to be integer since Enum exports to Java are not supported by &#34;gomobile&#34;
	See getSyncMode(syncMode int)
	 */
	public final native void setSyncMode(long v);
	
	/**
	 * UseLightweightKDF lowers the memory and CPU requirements of the key store
	scrypt KDF at the expense of security.
	See https://geth.ethereum.org/doc/Mobile_Account-management for reference
	 */
	public final native boolean getUseLightweightKDF();
	/**
	 * UseLightweightKDF lowers the memory and CPU requirements of the key store
	scrypt KDF at the expense of security.
	See https://geth.ethereum.org/doc/Mobile_Account-management for reference
	 */
	public final native void setUseLightweightKDF(boolean v);
	
	/**
	 * IPCPath is the requested location to place the IPC endpoint. If the path is
	a simple file name, it is placed inside the data directory (or on the root
	pipe path on Windows), whereas if it&#39;s a resolvable path name (absolute or
	relative), then that specific path is enforced. An empty path disables IPC.
	 */
	public final native String getIPCPath();
	/**
	 * IPCPath is the requested location to place the IPC endpoint. If the path is
	a simple file name, it is placed inside the data directory (or on the root
	pipe path on Windows), whereas if it&#39;s a resolvable path name (absolute or
	relative), then that specific path is enforced. An empty path disables IPC.
	 */
	public final native void setIPCPath(String v);
	
	@Override public boolean equals(Object o) {
		if (o == null || !(o instanceof NodeConfig)) {
		    return false;
		}
		NodeConfig that = (NodeConfig)o;
		Enodes thisBootstrapNodes = getBootstrapNodes();
		Enodes thatBootstrapNodes = that.getBootstrapNodes();
		if (thisBootstrapNodes == null) {
			if (thatBootstrapNodes != null) {
			    return false;
			}
		} else if (!thisBootstrapNodes.equals(thatBootstrapNodes)) {
		    return false;
		}
		long thisMaxPeers = getMaxPeers();
		long thatMaxPeers = that.getMaxPeers();
		if (thisMaxPeers != thatMaxPeers) {
		    return false;
		}
		boolean thisNoDiscovery = getNoDiscovery();
		boolean thatNoDiscovery = that.getNoDiscovery();
		if (thisNoDiscovery != thatNoDiscovery) {
		    return false;
		}
		boolean thisEthereumEnabled = getEthereumEnabled();
		boolean thatEthereumEnabled = that.getEthereumEnabled();
		if (thisEthereumEnabled != thatEthereumEnabled) {
		    return false;
		}
		long thisEthereumNetworkID = getEthereumNetworkID();
		long thatEthereumNetworkID = that.getEthereumNetworkID();
		if (thisEthereumNetworkID != thatEthereumNetworkID) {
		    return false;
		}
		String thisEthereumGenesis = getEthereumGenesis();
		String thatEthereumGenesis = that.getEthereumGenesis();
		if (thisEthereumGenesis == null) {
			if (thatEthereumGenesis != null) {
			    return false;
			}
		} else if (!thisEthereumGenesis.equals(thatEthereumGenesis)) {
		    return false;
		}
		long thisEthereumDatabaseCache = getEthereumDatabaseCache();
		long thatEthereumDatabaseCache = that.getEthereumDatabaseCache();
		if (thisEthereumDatabaseCache != thatEthereumDatabaseCache) {
		    return false;
		}
		String thisEthereumNetStats = getEthereumNetStats();
		String thatEthereumNetStats = that.getEthereumNetStats();
		if (thisEthereumNetStats == null) {
			if (thatEthereumNetStats != null) {
			    return false;
			}
		} else if (!thisEthereumNetStats.equals(thatEthereumNetStats)) {
		    return false;
		}
		String thisHTTPHost = getHTTPHost();
		String thatHTTPHost = that.getHTTPHost();
		if (thisHTTPHost == null) {
			if (thatHTTPHost != null) {
			    return false;
			}
		} else if (!thisHTTPHost.equals(thatHTTPHost)) {
		    return false;
		}
		long thisHTTPPort = getHTTPPort();
		long thatHTTPPort = that.getHTTPPort();
		if (thisHTTPPort != thatHTTPPort) {
		    return false;
		}
		String thisHTTPVirtualHosts = getHTTPVirtualHosts();
		String thatHTTPVirtualHosts = that.getHTTPVirtualHosts();
		if (thisHTTPVirtualHosts == null) {
			if (thatHTTPVirtualHosts != null) {
			    return false;
			}
		} else if (!thisHTTPVirtualHosts.equals(thatHTTPVirtualHosts)) {
		    return false;
		}
		String thisHTTPModules = getHTTPModules();
		String thatHTTPModules = that.getHTTPModules();
		if (thisHTTPModules == null) {
			if (thatHTTPModules != null) {
			    return false;
			}
		} else if (!thisHTTPModules.equals(thatHTTPModules)) {
		    return false;
		}
		boolean thisWhisperEnabled = getWhisperEnabled();
		boolean thatWhisperEnabled = that.getWhisperEnabled();
		if (thisWhisperEnabled != thatWhisperEnabled) {
		    return false;
		}
		String thisPprofAddress = getPprofAddress();
		String thatPprofAddress = that.getPprofAddress();
		if (thisPprofAddress == null) {
			if (thatPprofAddress != null) {
			    return false;
			}
		} else if (!thisPprofAddress.equals(thatPprofAddress)) {
		    return false;
		}
		long thisSyncMode = getSyncMode();
		long thatSyncMode = that.getSyncMode();
		if (thisSyncMode != thatSyncMode) {
		    return false;
		}
		boolean thisUseLightweightKDF = getUseLightweightKDF();
		boolean thatUseLightweightKDF = that.getUseLightweightKDF();
		if (thisUseLightweightKDF != thatUseLightweightKDF) {
		    return false;
		}
		String thisIPCPath = getIPCPath();
		String thatIPCPath = that.getIPCPath();
		if (thisIPCPath == null) {
			if (thatIPCPath != null) {
			    return false;
			}
		} else if (!thisIPCPath.equals(thatIPCPath)) {
		    return false;
		}
		return true;
	}
	
	@Override public int hashCode() {
	    return java.util.Arrays.hashCode(new Object[] {getBootstrapNodes(), getMaxPeers(), getNoDiscovery(), getEthereumEnabled(), getEthereumNetworkID(), getEthereumGenesis(), getEthereumDatabaseCache(), getEthereumNetStats(), getHTTPHost(), getHTTPPort(), getHTTPVirtualHosts(), getHTTPModules(), getWhisperEnabled(), getPprofAddress(), getSyncMode(), getUseLightweightKDF(), getIPCPath()});
	}
	
	@Override public String toString() {
		StringBuilder b = new StringBuilder();
		b.append("NodeConfig").append("{");
		b.append("BootstrapNodes:").append(getBootstrapNodes()).append(",");
		b.append("MaxPeers:").append(getMaxPeers()).append(",");
		b.append("NoDiscovery:").append(getNoDiscovery()).append(",");
		b.append("EthereumEnabled:").append(getEthereumEnabled()).append(",");
		b.append("EthereumNetworkID:").append(getEthereumNetworkID()).append(",");
		b.append("EthereumGenesis:").append(getEthereumGenesis()).append(",");
		b.append("EthereumDatabaseCache:").append(getEthereumDatabaseCache()).append(",");
		b.append("EthereumNetStats:").append(getEthereumNetStats()).append(",");
		b.append("HTTPHost:").append(getHTTPHost()).append(",");
		b.append("HTTPPort:").append(getHTTPPort()).append(",");
		b.append("HTTPVirtualHosts:").append(getHTTPVirtualHosts()).append(",");
		b.append("HTTPModules:").append(getHTTPModules()).append(",");
		b.append("WhisperEnabled:").append(getWhisperEnabled()).append(",");
		b.append("PprofAddress:").append(getPprofAddress()).append(",");
		b.append("SyncMode:").append(getSyncMode()).append(",");
		b.append("UseLightweightKDF:").append(getUseLightweightKDF()).append(",");
		b.append("IPCPath:").append(getIPCPath()).append(",");
		return b.append("}").toString();
	}
}

