// Code generated by gobind. DO NOT EDIT.

// Java class org.ethereum.geth.Transaction is a proxy for talking to a Go program.
//
//   autogenerated by gobind -lang=java -javapkg=org.ethereum github.com/ethereum/go-ethereum/mobile
package org.ethereum.geth;

import go.Seq;

/**
 * Transaction represents a single Ethereum transaction.
 */
public final class Transaction implements Seq.Proxy {
	static { Geth.touch(); }
	
	private final int refnum;
	
	@Override public final int incRefnum() {
	      Seq.incGoRef(refnum, this);
	      return refnum;
	}
	
	/**
	 * NewTransaction creates a new transaction with the given properties.
	 */
	public Transaction(long nonce, Address to, BigInt amount, long gasLimit, BigInt gasPrice, Address feeCurrency, Address gatewayFeeRecipient, BigInt gatewayFee, byte[] data) {
		this.refnum = __NewTransaction(nonce, to, amount, gasLimit, gasPrice, feeCurrency, gatewayFeeRecipient, gatewayFee, data);
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewTransaction(long nonce, Address to, BigInt amount, long gasLimit, BigInt gasPrice, Address feeCurrency, Address gatewayFeeRecipient, BigInt gatewayFee, byte[] data);
	
	/**
	 * NewTransactionFromJSON parses a transaction from a JSON data dump.
	 */
	public Transaction(String data) {
		this.refnum = __NewTransactionFromJSON(data);
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewTransactionFromJSON(String data);
	
	/**
	 * NewTransactionFromRLP parses a transaction from an RLP data dump.
	 */
	public Transaction(byte[] data) {
		this.refnum = __NewTransactionFromRLP(data);
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewTransactionFromRLP(byte[] data);
	
	Transaction(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
	
	/**
	 * EncodeJSON encodes a transaction into a JSON data dump.
	 */
	public native String encodeJSON() throws Exception;
	/**
	 * EncodeRLP encodes a transaction into an RLP data dump.
	 */
	public native byte[] encodeRLP() throws Exception;
	public native BigInt getCost();
	public native byte[] getData();
	/**
	 * Deprecated: use EthereumClient.TransactionSender
	 */
	public native Address getFrom(BigInt chainID) throws Exception;
	public native long getGas();
	public native BigInt getGasPrice();
	public native Hash getHash();
	public native long getNonce();
	/**
	 * Deprecated: GetSigHash cannot know which signer to use.
	 */
	public native Hash getSigHash();
	public native Address getTo();
	public native BigInt getValue();
	public native Transaction withSignature(byte[] sig, BigInt chainID) throws Exception;
	@Override public boolean equals(Object o) {
		if (o == null || !(o instanceof Transaction)) {
		    return false;
		}
		Transaction that = (Transaction)o;
		return true;
	}
	
	@Override public int hashCode() {
	    return java.util.Arrays.hashCode(new Object[] {});
	}
	
	@Override public String toString() {
		StringBuilder b = new StringBuilder();
		b.append("Transaction").append("{");
		return b.append("}").toString();
	}
}

